/*
 * File: ConsecutiveHeads.js
 * -------------------------
 * This program provided and unit tests the consecutiveHeads routine as
 * specified in Problem 3 of the second practice midterm.
 */

"use strict";

/**
 * Function: ConsecutiveHeads()
 * ----------------------------
 * Provides a test harness to ensure that consecutiveHeads, defined
 * below, works as expected.
 */

function ConsecutiveHeads() {
	for (let numHeadsNeeded = 2; numHeadsNeeded <= 5; numHeadsNeeded++) {
		console.log("How many coin flips to generate " + numHeadsNeeded + " consecutive heads?");
 		consecutiveHeads(numHeadsNeeded);
 	}
}

/**
 * Function: consecutiveHeads
 * --------------------------
 * Simulates the process of flipping a fair coin until the number of
 * consecutive heads matches the number supplied via numHeadsNeeded.
 */
function consecutiveHeads(numHeadsNeeded) {
	let numTosses = 0;
	let numHeads = 0;
	while (numHeads < numHeadsNeeded) {
		if (randomChance()) { // let true mean heads
			console.log("Heads");
			numHeads++;
		} else {
			console.log("Tails");
			numHeads = 0;
		}
		numTosses++;	
	}

	console.log("It took " + numTosses + " tosses to get " + numHeadsNeeded + " consecutive heads.");
}
